<?php

$query1 = "CREATE table IF NOT EXISTS company_info (
	id int unsigned not null auto_increment,
	primary key (id),
	name varchar(250) null,
	logo_ref text null,
	website varchar(250) null,
	email varchar(250) null,
	phone varchar(15) null,
	address varchar(250) null,
	other text null,
	slider text DEFAULT NULL,
	branches text
)";

$query3 = "CREATE table if not exists content (
	id int unsigned not null auto_increment,
	primary key (id),
	title varchar(250),
	body longtext DEFAULT NULL,
	image text DEFAULT NULL,
	view varchar(250),
	category varchar(250),
	industry varchar(250),
	business varchar(250),
	product varchar(250),
	product_desc text DEFAULT NULL,
	parent varchar(250),
	label varchar(250),
	type text DEFAULT NULL,
	auto varchar(255),
	status int(11) default 0,
	no_of_views int(11) default 0,
	user_id int(50) default 0,
	author int(50) NULL,
	date_uploaded DATETIME NULL DEFAULT CURRENT_TIMESTAMP,
	date_updated DATETIME NULL DEFAULT CURRENT_TIMESTAMP
)";

$query4 = "CREATE table if not exists roles (
	roleid int unsigned not null auto_increment,
	primary key (roleid),
	transcid varchar(50),
	rolename varchar(255),
	roledesc text DEFAULT NULL,
	clientid int
)";

$query5 = "CREATE table if not exists activitylog (
	id int(11) unsigned not null auto_increment,
	primary key (id),
	user_id int(50),
	action varchar(250),
	type varchar(10) default 'admin',
	location varchar(250),
	location_id varchar(50),
	description varchar(250),
	date DATETIME NULL DEFAULT CURRENT_TIMESTAMP
)";

$query7 = "CREATE table if not exists users (
	id int unsigned not null auto_increment,
	primary key (id),
	picture_ref varchar(255) null,
	first_name varchar(255) not null,
	middle_name varchar(255) null,
	last_name varchar(255) null,
	phone varchar(70) null,
	email varchar(70) null,
	state varchar(70) null,
	gender varchar(6) null,
	username varchar(50) not null,
	password text not null,
	bio varchar(300) null,
	type int(5) null,
	status int(5) default 0,
	roleId int default 0,
	accessLevel int default 0,
	address varchar(255) null,
	website varchar(255) null,
	other varchar(255) null,
	dob DATETIME NULL DEFAULT CURRENT_TIMESTAMP,
	date DATETIME NULL DEFAULT CURRENT_TIMESTAMP
)";

$query9 = "CREATE table if not exists subscribers (
	id int unsigned not null auto_increment,
	primary key (id),
	name varchar(250),
	email varchar(250),
	unique (email),
	user_id int(50) NULL,
	status int(20) DEFAULT 1,
	sub_date DATETIME NULL DEFAULT CURRENT_TIMESTAMP,
	unsub_date datetime NULL
)";

$query10 = "CREATE table if not exists conversation (
	id int unsigned not null auto_increment,
	primary key (id),
	post_id int(50) NULL,
	user_id int(50) NULL,
	parent_message int(11) NULL,
	title varchar(250) NULL,
	message text DEFAULT NULL,
	type varchar(250) NULL,
	user_name varchar(250) NULL,
	time DATETIME NULL DEFAULT CURRENT_TIMESTAMP
	)";




?>
