<?php

function form($status, $boost = [] ){
	$other = [];
	if(!empty($boost )){
		$other = [
			"column"=>"date_closing",
			"type"=>"date",
			"description"=>"Expiry Date",
			"class"=>"col s6 hide",
		];
		$boost = [
			"column"=>"promoted",
			"type"=>"switch",
			"description"=>"Promote ?",
			"source"=>"bool",
			"event"=>[
				"type"=>"onchange",
				"function"=>"showExpDate(this)"
			],
			"class"=>"col s6 mb-3",
		];
	}

	$form = [
		[
			"position"=>"left",
			"section_title"=>"Property Details",
			"section_elements"=>[
				[
					"column"=>"description",
					"description"=>"Property Title",
					"type"=>"text",
					"required"=>true,
					"class"=>"col s12",
				],
				[
					"column"=>"price1",
					"description"=>"Price",
					"type"=>"number",
					"required"=>true,
					"class"=>"col m3",
				],
				[
					"column"=>"unit",
					"description"=>"Lease Type",
					"type"=>"select",
					"required"=>true,
					"source"=>"asset_lease_type",
					"class"=>"col m3",
				],
				[
					"column"=>"warehouse",
					"description"=>"Location Address",
					"type"=>"text",
					"required"=>true,
					"class"=>"col m6",
				],
				[
					"column"=>"city",
					"description"=>"What City",
					"type"=>"text",
					"required"=>true,
					"class"=>"col m6",
				],
				[
					"column"=>"state",
					"description"=>"Select State",
					"type"=>"select",
					"required"=>true,
					"source"=>"states",
					"class"=>"col m6",
				],
				[
					"column"=>"latlong",
					"type"=>"hidden",
					"class"=>"col m6 hide",
				],

				[
					"column"=>"sales_desc",
					"description"=>"Property Description",
					"type"=>"richtext-body",
					// "readonly"=>true,
					"class"=>"col s12",
				],
			],
		],
		[
			"position"=>"right",
			"section_title"=>"Property Type/Tags",
			"section_elements"=>[
				[
					"column"=>"pcategories",
					"description"=>"Property Type",
					"type"=>"select",
					"source"=>"filtered-property-type",
					"class"=>"col s12 m6",
					"required"=>true,
					"empty"=>false,
					"event"=>[
						"type"=>"onchange",
						"function"=>"trigger_tags(this)"
					]
				],
				[
					"column"=>"itemid",
					"type"=>"text",
					"description"=>"Property ID",
					"class"=>"col m6 s12",
				],
				[
					"column"=>"tags",
					"description"=>"Property Tags",
					"type"=>"json-manager",
					"source"=>"property-type",
					// "readonly"=>true,
					"class"=>"col s12",
				],
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Modify Property Status",
			"section_elements"=>[
				$status,
				[
					"column"=>"comment",
					"description"=>"Send User an SMS",
					"type"=>"textarea",
					"class"=>"col s12 hide",
				],
				$boost,
				$other,
			]
		],
		[
			"position"=>"left",
			"section_title"=>"Property Media",
			"section_elements"=>[
				[
					"column"=>"picture",
					"type"=>"items",
					"required"=>true,
					// "readonly"=>true,
					"value"=>4,
					"class"=>"col s12 horizontal",
				]
			]
		],
	];
	return $form;
}
function product_form($status, $boost = [] ){
	

	$form = [
		[
			"position"=>"left",
			"section_title"=>"Product Details",
			"section_elements"=>[
				[
					"column"=>"description",
					"description"=>"Product Name",
					"type"=>"text",
					"required"=>true,
					"class"=>"col s12",
				],
				[
					"column"=>"price1",
					"description"=>"Price",
					"type"=>"number",
					"required"=>true,
					"class"=>"col m3",
				],
				[
					"column"=>"unit",
					"description"=>"Unit",
					"type"=>"text",
					"required"=>true,
					
					"class"=>"col m3",
				],
				
				[
					"column"=>"city",
					"description"=>"What City",
					"type"=>"text",
					"required"=>true,
					"class"=>"col m6",
				],
				[
					"column"=>"state",
					"description"=>"Select State",
					"type"=>"select",
					"required"=>true,
					"source"=>"states",
					"class"=>"col m6",
				],

				[
					"column"=>"sales_desc",
					"description"=>"Product Description",
					"type"=>"richtext-body",
					// "readonly"=>true,
					"class"=>"col s12",
				],
			],
		],
		
		
		[
			"position"=>"right",
			"section_title"=>"Product Media",
			"section_elements"=>[
				[
					"column"=>"picture",
					"type"=>"items",
					"required"=>true,
					// "readonly"=>true,
					"value"=>4,
					"class"=>"col s12 horizontal",
				]
			]
		],
		
		[
			"position"=>"right",
			"section_title"=>"Product Settings",
			"section_elements"=>[
				[
					"column"=>"pcategories",
					"description"=>"Product Type",
					"type"=>"select",
					"source"=>"filtered-property-type",
					"class"=>"col s12 m6",
					"required"=>true,
					"empty"=>false,
					
				],
				[
					"column"=>"status",
					"type"=>"select",
					"description"=>"Audit Status",
					"source"=>"property-status",
					"empty"=>false,
					"class"=>"col s6",
					"event"=>[
						"type"=>"onchange",
						"function"=>"sendmessage(this)",
					]
				],
			]
		],
	];
	return $form;
}
function service_form($status, $boost = [] ){
	

	$form = [
		[
			"position"=>"left",
			"section_title"=>"Product Details",
			"section_elements"=>[
				[
					"column"=>"description",
					"description"=>"Dervice Name",
					"type"=>"text",
					"required"=>true,
					"class"=>"col s12",
				],
				
				[
					"column"=>"city",
					"description"=>"What City",
					"type"=>"text",
					"required"=>true,
					"class"=>"col m6",
				],
				[
					"column"=>"state",
					"description"=>"Select State",
					"type"=>"select",
					"required"=>true,
					"source"=>"states",
					"class"=>"col m6",
				],

				[
					"column"=>"sales_desc",
					"description"=>"Service Description",
					"type"=>"richtext-body",
					// "readonly"=>true,
					"class"=>"col s12",
				],
			],
		],
		
		
		[
			"position"=>"right",
			"section_title"=>"Service Media",
			"section_elements"=>[
				[
					"column"=>"picture",
					"type"=>"items",
					"required"=>true,
					// "readonly"=>true,
					"value"=>4,
					"class"=>"col s12 horizontal",
				]
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Service Settings",
			"section_elements"=>[
				[
					"column"=>"pcategories",
					"description"=>"Service Type",
					"type"=>"select",
					"source"=>"service-categories",
					"class"=>"col s12 m6",
					"required"=>true,
					"empty"=>false,
					
				],
				[
					"column"=>"status",
					"type"=>"select",
					"description"=>"Audit Status",
					"source"=>"property-status",
					"empty"=>false,
					"class"=>"col s6",
					"event"=>[
						"type"=>"onchange",
						"function"=>"sendmessage(this)",
					]
				],
			]
		],
	];
	return $form;
}
function user_form(){
	$form = [
		[
			"position"=>"left",
			"section_title"=>"User Info",
			"section_elements"=>[
				[
						"column"=>"customername",
						"description"=>"Full Name",
						"required"=>true,
						"type"=>"text",
						"class"=>"col s12 m6"
				],
				
				[
						"description"=>"Gender",
						"required"=>true,
						"type"=>"select",
						"column"=>"gender",
						"source"=>"gender",
						"class"=>"col s12 m6"
				],
				[
						"column"=>"others",
						"description"=>"Bio / Company Details",
						"required"=>true,
						"type"=>"textarea",
						"class"=>"col s12"
				]
			]
		],
		[
			"position"=>"left",
			"section_title"=>"Contact Info",
			"section_elements"=>[
				[
					"column"=>"telephone",
					"description"=>"Phone Number",
					"class"=>"col s12 m6",
					"type"=>"text"
				],
				[
					"column"=>"email",
					"description"=>"Email",
					"class"=>"col s12 m6",
					"type"=>"text",
					"required"=>true,
				],
				[
					"column"=>"address",
					"description"=>"Residential Address",
					"class"=>"col s12",
					"type"=>"text"
				]
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Logo Picture",
			"section_elements"=>[
				[
					"column"=>"picture",
					"description"=>"Passport",
					"type"=>"picture",
					"class"=>"col s12 m12"
				]
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Security Settings",
			"section_elements"=>[
				[
					"column"=>"type",
					"description"=>"Category",
					"class"=>"col s12 m6",
					"type"=>"select",
					"required"=>true,
					"source"=>"user-category",
					"value"=>"****************",
				],
				[
					"column"=>"customer_since",
					"description"=>"Reg Date",
					"type"=>"date",
					"disabled"=>true,
					"readonly"=>true,
					"class"=>"col s12 m6",
					"source"=>"accessLevel",
				],
				[
					"column"=>"inactive",
					"description"=>"Activation",
					"type"=>"switch",
					"class"=>"col s12",
					"source"=>"active",
				],
			]
		]
	];
	return $form;
}
function user_form2(){
	$form = [
		[
			"position"=>"left",
			"section_title"=>"User Info",
			"section_elements"=>[
				[
						"column"=>"customername",
						"description"=>"Full Name",
						"required"=>true,
						"type"=>"text",
						"class"=>"col s12 m6"
				],
				
				[
						"description"=>"Organisation Type",
						"required"=>true,
						"type"=>"select",
						"column"=>"gender",
						"source"=>"company-type",
						"class"=>"col s12 m6"
				],
				[
						"column"=>"others",
						"description"=>"Bio / Company Details",
						"required"=>true,
						"type"=>"textarea",
						"class"=>"col s12"
				]
			]
		],
		[
			"position"=>"left",
			"section_title"=>"Contact Info",
			"section_elements"=>[
				[
					"column"=>"telephone",
					"description"=>"Phone Number",
					"class"=>"col s12 m6",
					"type"=>"text"
				],
				[
					"column"=>"email",
					"description"=>"Email",
					"class"=>"col s12 m6",
					"type"=>"text",
					"required"=>true,
				],
				[
					"column"=>"address",
					"description"=>"Residential Address",
					"class"=>"col s12",
					"type"=>"text"
				]
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Logo Picture",
			"section_elements"=>[
				[
					"column"=>"picture",
					"description"=>"Passport",
					"type"=>"picture",
					"class"=>"col s12 m12"
				]
			]
		],
		[
			"position"=>"right",
			"section_title"=>"Security Settings",
			"section_elements"=>[
				
				[
					"column"=>"inactive",
					"description"=>"Deactivation",
					"type"=>"switch",
					"class"=>"col s12",
					"source"=>"inactive",
				],
			]
		]
	];
	return $form;
}
?>
