<?php
$user_id = isset($_SESSION["user_id"]) ? $_SESSION["user_id"] : 0;
$user_al = isset($_SESSION["accesslevel"]) ? $_SESSION["accesslevel"] : 4;
$actLog = $user_al == 4 ? "" : ", user_id=$user_id";


$param = [
	"admin_signin"=> [ //Signin Parameters
		"table" 			=> "users",
		"primary_key"	=> "id",
		"username_col"=> "username",
		"password_col"=> "password",
		"name_col"  	=> "first_name",
		"email_col" 	=> "email",
		"image_col"		=> "picture_ref",
		"interface"		=> "signin2",
		"status_col"	=> "type",
		"status_val"	=> 1,
		"callback" 		=> "signin_log",
	],
	"organization"=>[//The current organization using the code
		"table"=>"company_info",
		"primary_key"=>"id",
		"key"=>1,
		"page_title"=>"Organization",
		"fixed"=>"id=1",
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Basic Company Info",
					"section_elements"=>[
						[
							"column"=>"name",
							"description"=>"Business Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"email",
							"description"=>"Email Address",
							"required"=>true,
							"type"=>"email",
							"class"=>"left col s12 m12"
						],[
							"column"=>"website",
							"description"=>"Website",
							"required"=>false,
							"type"=>"url",
							"class"=>"left col s12 m12"
						],[
							"column"=>"phone",
							"description"=>"Phone Number",
							"required"=>true,
							"type"=>"number",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"other",
							"description"=>"Short description of the site",
							"required"=>true,
							"type"=>"textarea",
							"class"=>"left col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Company Logo",
					"section_elements"=>[
						[
							"column"=>"logo_ref",
							"description"=>"Logo",
							"required"=>true,
							"type"=>"picture",
							"value"=>1,
							"class"=>"left col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Social Media Handles",
					"section_elements"=>[

						[
							"column"=>"facebook",
							"description"=>"Facebook Handle",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"twitter",
							"description"=>"Twitter Handle",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"likedin",
							"description"=>"LinkedIn Handle",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"youtube",
							"description"=>"Youtube Handle",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"instagram",
							"description"=>"Instagram Handle",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						]
					]
				]
			]
		]
	],
	"states"=>[
		"table"=>"location",
		"fixed_values"=>"parent_id='0'",
		"retrieve_filter"=>"parent_id='0'",
		"primary_key"=>"id",
		"page_title"=>"States",
		"display_fields"=>[
			[
				"column"=>"name",
				"description"=>"States",
				"component"=>"span"
			]
		],
		"form"=>[
			"form_view"=>"modal",
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Add / Edit States",
					"section_elements"=>[
						[
							"column"=>"name",
							"description"=>"State Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						]
					]
				]
			]
		]
	],
	"role"=>[
		"table"=>"roles",
		"primary_key"=>"roleid",
		"page_title"=>"Roles",
		"display_fields"=>[
			[
				"column"=>"rolename",
				"description"=>"Role Name",
				"component"=>"span"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Role Info",
					"section_elements"=>[
						[
							"column"=>"rolename",
							"description"=>"Role Name",
							"type"=>"text",
							"required"=>true,
							"class"=>"left col s12 m12"
						],[
							"column"=>"roledesc",
							"required"=>true,
							"type"=>"roles",
							"class"=>"left col s12 m12"
						]
					]
				]
			]
		]
	],
	"postCategory"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"pre_submit_function"=>"slug",
		"fixed_values"=>"category='0',status=1,type='postCategory',no_of_views='0',parent='0',user_id='$user_id',author='$user_id'",
		"retrieve_filter"=>"type=postCategory,parent=0",
		"page_title"=>"Post Category",
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Categories",
				"component"=>"span",
			]
		],
		"form"=>[
			"form_view"=>"modal",
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Add/Edit Tips Category",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Category Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],
	"posts"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"page_title"=>"Posts",
		"fixed_values"=>"type=blog,no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type=blog",
		"extra_values"=>"date_updated=now()",
		"sort"=>"date_uploaded DESC",
		"pre_submit_function"=>"slug",
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Title",
				"component"=>"span",
				"class"=>"col s5",
			],
			[
				"column"=>"category",
				"description"=>"Category",
				"component"=>"span",
				"action"=>"select",
				"source"=>"postCategory",
				"class"=>"col s2",
			],
			[
				"column"=>"status",
				"description"=>"Published ?",
				"component"=>"span",
				"action"=>"select",
				"source"=>"bool",
				"class"=>"col s2",
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"component"=>"span",
				"action"=>"date",
				"class"=>"col s3",
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"right",
					"section_title"=>"",
					"section_elements"=>[
						[
							"column"=>"image",
							"description"=>"Upload Post Image",
							"type"=>"generic-slider",
							"class"=>"col s12 m12",
							"required"=>true
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Post Title",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Post Title",
							"required"=>true,
							"type"=>"richtext-title",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Post Body",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Post Body",
							"required"=>true,
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
                       [
							"column"=>"author",
							"source"=>"admins",
							"description"=>"Select Author",
							"required"=>true,

							"type"=>"select",
							"class"=>"col s12 m6"
						],[
							"column"=>"category",
							"source"=>"postCategory",
							"description"=>"Select Category",
							"required"=>true,

							"type"=>"select",
							"class"=>"col s12 m6"
						],
						[
							"column"=>"status",
							"source"=>"publish",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s12 m12"
						]
					]
				],

			]
		]
	],"services"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"page_title"=>"Services",
		"fixed_values"=>"type=service,no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type=service",
		"extra_values"=>"date_updated=now()",
		"sort"=>"date_uploaded DESC",
		"pre_submit_function"=>"slug",
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Title",
				"component"=>"span",
				"class"=>"col s5",
			],
			[
				"column"=>"category",
				"description"=>"Category",
				"component"=>"span",
				"action"=>"select",
				"source"=>"postCategory",
				"class"=>"col s2",
			],
			[
				"column"=>"status",
				"description"=>"Published ?",
				"component"=>"span",
				"action"=>"select",
				"source"=>"bool",
				"class"=>"col s2",
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"component"=>"span",
				"action"=>"date",
				"class"=>"col s3",
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"right",
					"section_title"=>"",
					"section_elements"=>[
						[
							"column"=>"image",
							"description"=>"Upload Post Image",
							"type"=>"generic-slider",
							"class"=>"col s12 m12",
							"required"=>false
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Title",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Post Title",
							"required"=>true,
							"type"=>"richtext-title",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Service Detail",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Details",
							"required"=>true,
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
                       
						[
							"column"=>"status",
							"source"=>"publish",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s12 m12"
						]
					]
				],

			]
		]
	],"videos"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"page_title"=>"Video Links",
		"fixed_values"=>"type=video,no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type=video",
		"extra_values"=>"date_updated=now()",
		"sort"=>"date_uploaded DESC",
		"pre_submit_function"=>"slug",
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Title",
				"component"=>"span",
				"class"=>"col s5",
			],
			[
				"column"=>"category",
				"description"=>"Category",
				"component"=>"span",
				"action"=>"select",
				"source"=>"postCategory",
				"class"=>"col s2",
			],
			[
				"column"=>"status",
				"description"=>"Published ?",
				"component"=>"span",
				"action"=>"select",
				"source"=>"bool",
				"class"=>"col s2",
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"component"=>"span",
				"action"=>"date",
				"class"=>"col s3",
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Add Video Title",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Post Title",
							"required"=>true,
							"type"=>"text",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Video Link",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Link",
							"required"=>true,
							"type"=>"text",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
                       
						[
							"column"=>"status",
							"source"=>"publish",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s12 m12"
						]
					]
				],

			]
		]
	],"testimonials"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"page_title"=>"Testimonials",
		"fixed_values"=>"type=testimonial,no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type=testimonial",
		"extra_values"=>"date_updated=now()",
		"sort"=>"date_uploaded DESC",
		"pre_submit_function"=>"slug",
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Title",
				"component"=>"span",
				"class"=>"col s5",
			],
			[
				"column"=>"category",
				"description"=>"Category",
				"component"=>"span",
				"action"=>"select",
				"source"=>"postCategory",
				"class"=>"col s2",
			],
			[
				"column"=>"status",
				"description"=>"Published ?",
				"component"=>"span",
				"action"=>"select",
				"source"=>"bool",
				"class"=>"col s2",
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"component"=>"span",
				"action"=>"date",
				"class"=>"col s3",
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"right",
					"section_title"=>"",
					"section_elements"=>[
						[
							"column"=>"image",
							"description"=>"Upload Person Image",
							"type"=>"generic-slider",
							"class"=>"col s12 m12",
							"required"=>true
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Name Of Person",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Post Title",
							"required"=>true,
							"type"=>"richtext-title",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Testimonial",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Post Body",
							"required"=>true,
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
                       
						[
							"column"=>"status",
							"source"=>"publish",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s12 m12"
						]
					]
				],

			]
		]
	],
	"admins"=>[
		"table"=>"users",
		"primary_key"=>"id",
		"page_title"=>"Admins",
		"sort"=>"id Desc",
		"fixed_values"=>"status='1'",
		"retrieve_filter"=>"status=1",
		"display_fields"=>[
			[
				"column"=>"first_name",
				"description"=>"First Name",
				"component"=>"span"
			],
			[
				"column"=>"last_name",
				"description"=>"Last Name",
				"component"=>"span"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Personal Info",
					"section_elements"=>[
						[
							"column"=>"first_name",
							"description"=>"First Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],
						[
							"column"=>"last_name",
							"description"=>"Last Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						]
						,[
							"column"=>"email",
							"description"=>"Email Address",
							"required"=>true,
							"type"=>"email",
							"class"=>"left col s12 m12"
						],[
							"column"=>"address",
							"description"=>"Address",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"contact",
							"description"=>"Phone Numbers",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"date",
							"description"=>"Date Registered",
							"type"=>"text",
							"disabled"=>true,
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"User's Image",
					"section_elements"=>[
						[
							"column"=>"picture_ref",
							"description"=>"Photo",
							"required"=>true,
							"type"=>"picture",
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Login Details",
					"section_elements"=>[
						[
							"column"=>"username",
							"description"=>"Username",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"password",
							"description"=>"Password",
							"type"=>"password",
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Admin Access",
					"section_elements"=>[
						[
							"column"=>"status",
							"description"=>"Select Membership",
							"type"=>"select",
							"empty"=>false,
							"source"=>"admin_status",
							"class"=>"col s12 m12"
						],[
							"column"=>"roleid",
							"description"=>"Role to Perform",
							"type"=>"select",
							"required"=>true,
							"empty"=>false,
							"class"=>"left col s12 m12",
							"source"=>"role",
						],[
							"column"=>"accesslevel",
							"description"=>"Access Level",
							"type"=>"select",
							"required"=>true,
							"empty"=>false,
							"class"=>"left col s12 m12",
							"source"=>"accessLevel",
						]
					]
				]
			]
		]
	],
	"members"=>[
		"table"=>"users",
		"primary_key"=>"id",
		"page_title"=>"Members",
		"fixed_values"=>"status='0'",
		"sort"=>"id Desc",
		"retrieve_filter"=>"status='0'",
		"display_fields"=>[
			[
				"column"=>"full_name",
				"description"=>"Full Name",
				"component"=>"span"
			],[
				"column"=>"date",
				"description"=>"Date Registered",
				"component"=>"span",
				"action"=>"date"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"left",
					"section_title"=>"Personal Info",
					"section_elements"=>[
						[
							"column"=>"full_name",
							"description"=>"Full Name",
							"required"=>true,
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"email",
							"description"=>"Email Address",
							"required"=>true,
							"type"=>"email",
							"class"=>"left col s12 m12"
						],[
							"column"=>"address",
							"description"=>"Address",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"contact",
							"description"=>"Phone Numbers",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"date",
							"description"=>"Date Registered",
							"type"=>"text",
							"disabled"=>true,
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"User's Image",
					"section_elements"=>[
						[
							"column"=>"member_pic",
							"description"=>"Photo",
							"required"=>true,
							"type"=>"picture",
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Login Details",
					"section_elements"=>[
						[
							"column"=>"username",
							"description"=>"Username",
							"type"=>"text",
							"class"=>"left col s12 m12"
						],[
							"column"=>"password",
							"description"=>"Password",
							"type"=>"password",
							"class"=>"left col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Admin Access",
					"section_elements"=>[
						[
							"column"=>"status",
							"description"=>"Select Membership",
							"type"=>"select",
							"empty"=>false,
							"source"=>"admin_status",
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],
	"subscribers"=>[
		"table"=>"subscribers",
		"primary_key"=>"id",
		"page_title"=>"Subscribers",
		"sort"=>"id Desc",
		"listFAB"=>["delete"],
		"display_fields"=>[
			[
				"column"=>"email",
				"description"=>"Email",
				"component"=>"span"
			]
		],
		"form"=>[
			"form_view"=>"modal",
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"Subscriber Info",
					"section_elements"=>[
						[
							"column"=>"email",
							"description"=>"Email",
							"type"=>"email",
							"required"=>true,
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],
	"log"=>[
		"table"=>"activitylog",
		"primary_key"=>"id",
		"page_title"=>"Activities",
		"listFAB"=>["refresh"],
		"retrieve_filter"=>"$actLog",
		"sort"=>"id DESC",
		"display_fields"=>[
			[
				"column"=>"action",
				"description"=>"Action",
				"component"=>"span"
			],[
				"column"=>"description",
				"description"=>"Description",
				"component"=>"span"
			],[
				"column"=>"date",
				"description"=>"Time",
				"component"=>"span",
				"action"=>"datetime"
			]
		],
		"form"=>[
			"form_view"=>"modal",
			"sections"=>[
				[
					"position"=>"center",
					"section_title"=>"",
					"section_elements"=>[
						[
							"column"=>"description",
							"description"=>"Event",
							"type"=>"text",
							"readonly"=>true,
							"class"=>"col s12 m12"
						]
					]
				]
			]
		]
	],
	"lists"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"fixed_values"=>"type='listing',no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type='listing' and parent!='0'",
		"page_title"=>"Listing Posts",
		"pre_submit_function"=>"runTipThings",
		"sort"=>"id ASC",
		"display_level"=>[
			"source"=>"list_titles",
			"column"=>"parent",
			"loadform"=>true,
		],
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"Title",
				"component"=>"span",
				"class"=>"col s12 m5"
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date",
				"component"=>"span",
				"action"=>"datetime",
				"class"=>"col s12 m2"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"right",
					"section_title"=>"Upload Post Image",
					"section_elements"=>[
						[
							"column"=>"image",
							"type"=>"generic-slider",
							"class"=>"col s12 m12",
							"required"=>true
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Add Post Title",
					"section_elements"=>[
                        [
							"column"=>"title",
							"description"=>"Post Title",
							"required"=>true,
							"type"=>"richtext-title",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"right",
					"section_title"=>"Add Post Body",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Post Body",
							"required"=>true,
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				],[
					"position"=>"left",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
						[
							"column"=>"author",
							"source"=>"admins",
							"description"=>"Select Author",
							"required"=>true,
							"empty"=>true,
							"type"=>"select",
							"class"=>"col s12 m4"
						],[
							"column"=>"status",
							"source"=>"publish",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s12 m8"
						]

					]
				]
			]
		]
	],
	"list_titles"=>[
		"table"=>"content",
		"primary_key"=>"id",
		"fixed_values"=>"type='listing',no_of_views='0',user_id='$user_id'",
		"retrieve_filter"=>"type='listing' and parent='0'",
		"page_title"=>"Listing Titles",
		"pre_submit_function"=>"slug",
		"sort"=>"id DESC",
		"listFAB"=>["add", "refresh", "delete"],
		"extension"=>[
			"edit_listing"
		],
		"category"=>[
            [
				"name"=>"Show All",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Published",
				"value"=>"1",
				"type"=>"select",
			],
			[
				"column"=>"status",
				"name"=>"Filter by Drafts",
				"value"=>"0",
				"type"=>"select",
			],
			[
				"column"=>"category",
				"name"=>"Filter by category",
				"source"=>"postCategory",
				"type"=>"select",
			],
			[
				"column"=>"date_uploaded",
				"name"=>"Filter by Date",
				"type"=>"period"
			]
		],
		"display_fields"=>[
			[
				"column"=>"title",
				"description"=>"List Captions",
				"component"=>"span",
				"class"=>"col s12 m4"
			],
			[
				"column"=>"parent",
				"description"=>"No of Posts",
				"table"=>"content",
				"component"=>"span",
				"action"=>"count",
				"class"=>"col s12 m2"
			],
			[
				"column"=>"category",
				"description"=>"Category",
				"component"=>"span",
				"action"=>"select",
				"source"=>"postCategory",
				"class"=>"col s12 m2"
			],
			[
				"column"=>"author",
				"description"=>"Author",
				"component"=>"span",
				"action"=>"select",
				"source"=>"admins",
				"class"=>"col s12 m2"
			],
			[
				"column"=>"date_uploaded",
				"description"=>"Date Posted",
				"component"=>"span",
				"action"=>"datetime",
				"class"=>"col s12 m2"
			]
		],
		"form"=>[
			"sections"=>[
				[
					"position"=>"right",
					"section_title"=>"Upload Post Image",
					"section_elements"=>[
						[
							"column"=>"image",
							"type"=>"generic-slider",
							"class"=>"col s12 m12",
							"required"=>true
						]
					]
				],
				[
					"position"=>"left",
					"section_title"=>"Post Title",
					"section_elements"=>[
						[
							"column"=>"title",
							"description"=>"Add Post Title",
							"required"=>true,
							"type"=>"richtext-title",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"left",
					"section_title"=>"Post body",
					"section_elements"=>[
						[
							"column"=>"body",
							"description"=>"Add Post Content",
							"required"=>true,
							"type"=>"richtext-body",
							"class"=>"col s12 m12"
						]
					]
				],
				[
					"position"=>"right",
					"section_title"=>"Choose Post Settings",
					"section_elements"=>[
						[
							"column"=>"author",
							"source"=>"admins",
							"description"=>"Select Author",
							"required"=>true,
							"empty"=>true,
							"type"=>"select",
							"class"=>"col s12 m4"
						],[
							"column"=>"status",
							"source"=>"publish",
							"description"=>"Select Author",
							"type"=>"switch",
							"empty"=>false,
							"class"=>"col s6 m4"
						],[
							"column"=>"category",
							"source"=>"postCategory",
							"description"=>"Select Category",
							"required"=>true,

							"type"=>"select",
							"class"=>"col s6 m4"
						],[
							"column"=>"parent",
							"value"=>"0",
							"type"=>"hidden",
							"hidden"=>true,
							"class"=>"col s12 m4"
						]
					]
				]
			]
		]
	],



























//new page





];



?>
