<?php
$year    = date("Y");
$reports = [
  "financial-report"=>[
    "table"=>"transactions",
    "primary_key"=>"tid",
    "sort"=>"date_created desc",
    "page_title"=>"Financial Report",
    "report_type"=>"basics",
    "icon"=>"bubble_chart",
    "group_trans"=>1,
    "limit"=>10,
    "retrieve_filter"=>"sub<>0",
    "listFAB"=>["financial-report"],
    "report_setup"=>[
      "display_fields"=>[
        [
          "column"=>"trans_no",
          "name"=>"trans_no",
          "description"=>"Transaction ID",
          "grouping"=>true,
          "checked"=>true,
          "type"=>"text",
        ],
        [
          "column"=>"description",
          "name"=>"description",
          "description"=>"Transaction Description",
          "grouping"=>true,
          "checked"=>true,
          "type"=>"text",
          // "source"=>[
          //   "pageType"=>'routes',
          //   "column"=>["departure","arrival"],
          // ],
        ],
        [
          "column"=>"it_type",
          "name"=>"it_type",
          "description"=>"Payment for",
          "grouping"=>true,
          "checked"=>true,
          "type"=>"text",
        ],

        [
          "column"=>"cid",
          "name"=>"cid",
          "description"=>"Customer",
          "grouping"=>true,
          "checked"=>true,
          "filter"=>true,
          "type"=>"select",
          "value"=>"cid",
          "source"=>"members_",
        ],
        [
          "column"=>"sum(amount)",
          "name"=>"amount",
          "description"=>"Transaction Amount",
          "checked"=>true,
          "graph"=>true,
          "type"=>"number",
        ],
        [
          "column"=>"blank",
          "name"=>"blank",
          "type"=>"number",
          "description"=>"Number Counted",
        ],
        [
          "column"=>"count(*)",
          "name"=>"counted",
          "graph"=>true,
          "type"=>"number",
          "description"=>"Number of Transactions",
        ],
        [
          "column"=>"date(date_created)",
          "name"=>"date_due",
          "description"=>"Transaction Date",
          "grouping"=>true,
          "type"=>"date",
        ],
        [
          "column"=>"trans_type",
          "name"=>"trans_type",
          "description"=>"Type Of Transaction",
          "grouping"=>true,
          "filter"=>true,
          "source"=>"typ_of_transactions",
          "value"=>"key",
          "multiple"=>"value",
          "type"=>"hidden",
        ]
      ],
      "sections"=>[
        "date",
        "grouping",
        "filters",
      ],
      "datecol"=>"date_created"
    ],
    "display_fields"=>[
      [
        "column"=>"sum(gl_amount)",
        "name"=>"today",
        "description"=>"Today",
        "filter"=>getDateValue("Today","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ],
      [
        "column"=>"sum(gl_amount)",
        "name"=>"yesterday",
        "description"=>"Yesterday",
        "filter"=>getDateValue("Yesterday","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ],
      [
        "column"=>"sum(gl_amount)",
        "name"=>"this_week",
        "description"=>"This Week",
        "filter"=>getDateValue("This Week","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ],
      [
        "column"=>"sum(gl_amount)",
        "name"=>"last_week",
        "description"=>"Last Week",
        "filter"=>getDateValue("Last Week","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ],
      [
        "column"=>"sum(gl_amount)",
        "name"=>"this_month",
        "description"=>"This Month",
        "filter"=>getDateValue("This Month","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ],
      [
        "column"=>"sum(gl_amount)",
        "name"=>"last_month",
        "description"=>"Last Month",
        "filter"=>getDateValue("Last Month","date_created")." AND sub<>0",
        "class"=>"col s12 m2",
        "action"=>"myround",
      ]
    ],
    "form"=>[
      "sections"=>[
        [
          "position"=>"left-mini",
          "section_title"=>"General Monthly Transactions",
          "section_elements"=>[
            [
              "column"=>"sum(gl_amount)",
              "name"=>"latest_graph",
              "type"=>"line-graph",
              "source"=>"months",
              "filter"=>"YEAR(date_created)='$year' AND sub<>0 GROUP BY MONTH(date_created)",
              "class"=>"col s12"
            ],
          ],
        ],
        [
          "position"=>"left-mini",
          "section_title"=>"Monthly Expenses",
          "section_elements"=>[
            [
              "column"=>"sum(gl_amount)",
              "name"=>"charges",
              "type"=>"line-graph",
              "source"=>"months",
              "filter"=>"YEAR(date_created)='$year' AND trans_type='EXP' AND sub<>0 GROUP BY MONTH(date_created)",
              "class"=>"col s12"
            ]
          ],
        ],
        [
          "position"=>"middle",
          "section_title"=>"Monthly Promotions",
          "section_elements"=>[
            [
              "column"=>"sum(gl_amount)",
              "name"=>"monthly_booking",
              "source"=>"months",
              "type"=>"pie-chart",
              "filter"=>"trans_type='PCH' AND sub<>0 AND YEAR(date_created)='$year' GROUP BY MONTH(date_created)",
              "class"=>"col s12"
            ]
          ]
        ],
        [
          "position"=>"middle",
          "section_title"=>"Monthly Property Sales",
          "section_elements"=>[
            [
              "column"=>"sum(gl_amount)",
              "name"=>"monthly_courier",
              "source"=>"months",
              "type"=>"pie-chart",
              "filter"=>"trans_type='RCP' AND sub<>0 AND YEAR(date_created)='$year' GROUP BY MONTH(date_created)",
              "class"=>"col s12"
            ],

          ]
        ],
        [
          "position"=>"middle",
          "section_title"=>"Lifting Form Sales",
          "section_elements"=>[
            [
              "column"=>"sum(gl_amount)",
              "name"=>"monthly_form",
              "source"=>"months",
              "type"=>"pie-chart",
              "filter"=>"trans_type='FOM' AND sub<>0 AND YEAR(date_created)='$year' GROUP BY MONTH(date_created)",
              "class"=>"col s12"
            ],

          ]
        ],
        [
          "position"=>"right",
          "section_title"=>"Latest Transactions",
          "section_elements"=>[
            [
              "column"=>"latest",
              "required"=>true,
              "source"=>[
                "pageType"=>"financial-report",
                "column" =>["description", "gl_amount"]
              ],
              "type"=>"table",
              "class"=>"col s12"
            ],
          ]
        ],
        [
          "position"=>"left-mini",
          "section_title"=>"Top 5 customers this month",
          "section_elements"=>[
            [
              "column"=>"top5",
              "required"=>true,
              "source"=>[
                "pageType"=>"top5-customers",
                "column" =>["customer", "telephone", "concat('₦', sum(gl_amount))"]
              ],
              "type"=>"table",
              "class"=>"col s12"
            ],
          ]
        ]
      ]
    ]
  ],

  "top5-customers"=>[
    "table"=>"transactions",
    "primary_key"=>"tid",
    "retrieve_filter"=>getDateValue("This Month","date_created")." AND sub<>0 GROUP BY cid",
    "page_title"=>"Top 5 Customers",
    "sort"=>"amount DESC",
    "limit"=>"5",
  ]
];
?>
